com.hazelcast.jet.pipeline

## Class SessionWindowDef<T>

- java.lang.Object
- - com.hazelcast.jet.pipeline.SessionWindowDef<T>

- Type Parameters:
    `T` - type of the stream item
  All Implemented Interfaces:
    WindowDefinition

      public class SessionWindowDef<T>
      extends Object
      implements WindowDefinition

  Represents the definition of a `session` window.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.hazelcast.jet.pipeline.WindowDefinition

      `WindowDefinition.WindowKind`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `SessionWindowDef<T>` | `downcast()` Returns this window definition downcast to the type determined through type inference at the call site.
    `WindowDefinition.WindowKind` | `kind()` Returns what kind of window this definition describes.
    `long` | `sessionTimeout()` Returns the session timeout, which is the largest difference in the timestamps of any two consecutive events in the session window.
    `long` | `watermarkFrameSize()` Returns the frameLength and offset this window definition needs.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.hazelcast.jet.pipeline.WindowDefinition

      `session, sliding, tumbling`

- - ### Method Detail

    - #### kind

          @Nonnull
          public WindowDefinition.WindowKind kind()

      Description copied from interface: `WindowDefinition`
      Returns what kind of window this definition describes.
      Specified by:
        `kind` in interface `WindowDefinition`

    - #### downcast

          @Nonnull
          public SessionWindowDef<T> downcast()

      Description copied from interface: `WindowDefinition`
      Returns this window definition downcast to the type determined through type inference at the call site. It will be an unchecked downcast and may fail at runtime with a `ClassCastException`.
      Specified by:
        `downcast` in interface `WindowDefinition`
      Returns:
        this object, downcast into the inferred type

    - #### watermarkFrameSize

          public long watermarkFrameSize()

      Description copied from interface: `WindowDefinition`
      Returns the frameLength and offset this window definition needs.
      Specified by:
        `watermarkFrameSize` in interface `WindowDefinition`

    - #### sessionTimeout

          public long sessionTimeout()

      Returns the session timeout, which is the largest difference in the timestamps of any two consecutive events in the session window.

Copyright © 2018. All rights reserved.